from dune.perftool.generation import preamble, symbol


@preamble
def define_geometry(name):
    return "auto {} = eg.geometry();".format(name)


@symbol
def name_geometry():
    define_geometry("geo")
    return "geo"


@symbol
def name_dimension():
    # TODO preamble define_dimension
    return "dim"


@preamble
def define_jacobian_inverse_transposed(name):
    geo = name_geometry()
    return "auto {} = {}.jacobianInverseTransposed();".format(name,
                                                              geo,
                                                              )


@symbol
def name_jacobian_inverse_transposed():
    define_jacobian_inverse_transposed("J")
    return "J"
