from dune.perftool.generation import (domain,
                                      iname,
                                      instruction,
                                      symbol,
                                      temporary_variable,
                                      )
from dune.perftool.pdelab.geometry import (name_geometry,
                                           )

@iname
def quadrature_iname():
    domain("q", "q_n")
    return "q"


def quadrature_preamble(code, **kw):
    return instruction(inames=quadrature_iname(), code=code, **kw)


@symbol
def name_quadrature_rule():
    return "rule"


@symbol
def name_quadrature_point():
    rule = name_quadrature_rule()
    return "{}.position()".format(rule)


def define_quadrature_factor(fac):
    rule = name_quadrature_rule()
    geo = name_geometry()
    qp = name_quadrature_point()
    code = "{} = {}->weight()*{}.integrationElement({});".format(fac,
                                                                 rule,
                                                                 geo,
                                                                 qp,
                                                                 )
    return quadrature_preamble(code, assignees=fac)


@symbol
def name_factor():
    temporary_variable("fac", shape=())
    define_quadrature_factor("fac")
    return "fac"
